/**
 * 简单包装主动定位的函数，主要提供
 * 当定位完成回调指定函数的功能。
 */
var PosHelper = 
{
	//总体是否在继续
	positioning : false,
	//总体是否成功
	positionSuccess :  false,
	//gps定位是否成功
	gpsSuccess : null,
	//基站定位是否成功
	cellSuccess: null,
	//逆地理查询是否成功
	inverseQuerySuccess : false,
	
	posData  : null,
	callbackContext : 
	{
		callback: null,
		caller  : null,
		autoCall: false
	},
	start : function()
	{
		this.positioning = true;
		startPos("PosHelper.onPosCallback",false);
	},
	
	cancel : function()
	{
		if(_gpsObj)
		{
			_gpsObj.stopPosition();
		}
	},
	
	onPosCallback : function(msgType, data)
	{
		this.positioning = false;
		//gps定位成功，或者基站定位成功
		if(_MSG_POS_GPS==msgType || _MSG_POS_CELL==msgType)
		{
			if(_MSG_POS_GPS==msgType)
			{
				this.gpsSuccess = true;
			}
			if(_MSG_POS_CELL==msgType)
			{
				this.cellSuccess= true;
			}
			
			this.posData = data;
			this.positionSuccess = true;
			this.invokeCallback();
		}
		//定位是否成功
		else if(_MSG_FAIL_GPS==msgType || _MSG_FAIL_CELL==msgType)
		{
			if (_MSG_FAIL_GPS==msgType)
			{
				this.gpsSuccess = false;
			}
			if (_MSG_FAIL_CELL==msgType)
			{
				this.cellSuccess= false;
			}
			
			//声明了需要GPS或者cell
			if(true == _needGps && true == _needCell)
			{
				//都失败了，调用失败回调
				if (false==this.gpsSuccess && false==this.cellSuccess)
				{
					this.positionSuccess = false;
					this.invokeCallback();
				}
			}
			//只要GPS
			else if(true == _needGps && false == _needCell)
			{
				//GPS失败就是失败
				if (false==this.gpsSuccess)
				{
					this.positionSuccess = false;
					this.invokeCallback();
				}
			}
			//只要cell
			else if(false == _needGps && true == _needCell)
			{
				//cell失败就是失败
				if(false==this.cellSuccess)
				{
					this.positionSuccess = false;
					this.invokeCallback();
				}
			}
			//两个都不要？调用的地方写错了
			else
			{
				this.positionSuccess = false;
				this.invokeCallback();
			}
			
		}
		//逆地理查询成功
		else if(_MSG_GPS_CITY==msgType || _MSG_CELL_CITY==msgType)
		{
			//
		}
		//逆地理查询失败
		else if (msgType==_MSG_ERROR_CITY)
		{
			//
		}
	},
	
	isPositioninng : function()
	{
		return this.positioning;
	},
	
	doWhenPositionFinished : function(callback, caller)
	{
		this.callbackContext.autoCall = true;
		this.callbackContext.callback = callback;
		this.callbackContext.caller   = caller;
		
		if(!this.positioning && this.posData)
		{
			this.invokeCallback();
		}
	},
	
	invokeCallback : function()
	{
		if(this.callbackContext.autoCall && this.callbackContext.callback)
		{
			if(this.callbackContext.caller)
			{
				this.callbackContext.callback.apply(this.callbackContext.caller);
			}
			else
			{
				this.callbackContext.callback();
			}
		}
	},
	
	getPos : function()
	{
		if(this.posData)
		{
			return this.posData.pos;
		}
		else
		{
			return "";
		}
	},
	
	isPositioning : function()
	{
		return this.positioning;
	},
	
	isPositionSuccess: function()
	{
		return this.positionSuccess;
	}
	
};