/**
 * 提供应用程序级别的数据存储支持，在3.2.5版本的基座中，
 * 直接使用其提供的window.set(XXX)Session功能代理实现
 * 
 */
var Session = {
	/**
	 * 
	 */
	KEY:{
		USERNAME: "username",
		UNREADED_NOTES_COUNT: "unreaded_notes_count",
		TODO_TASKS_COUNT: "todo_tasks_count",
	},
	
	/**
	 * 获取指定键的对应值
	 */
	get: function(key)
	{
		return window.getStringSession(key);
	},
	
	/**
	 * 存储一个键值对
	 */	
	set: function(key, value)
	{
		window.setStringSession(key, value);
	},
	
	/**
	 * 存储用户名(当前登录的)
	 */
	setUserName: function(username)
	{
		this.set(this.KEY.USERNAME, username);
	},
	
	/**
	 * 返回保存的登录用户名
	 */
	getUserName: function(username)
	{
		return this.get(this.KEY.USERNAME);
	},
	
	/**
	 * 获取当前人未读通知公告的数量
	 */
	getUnreadedNotesCount: function()
	{
		return this.get(this.KEY.UNREADED_NOTES_COUNT);
	},
	
	/**
	 * 设置当前人的未读通知公告数量
	 */
	setUnreadedNotesCount: function(number)
	{
		this.set(this.KEY.UNREADED_NOTES_COUNT, number);
	},
	
	decreaseUnreadedCount: function()
	{
		var count = this.getUnreadedNotesCount();
		count --;
		this.setUnreadedNotesCount(count);
	},
	
	getTodoTasksCount : function()
	{
		return this.get(this.KEY.TODO_TASKS_COUNT);
	},
	
	setTodoTasksCount : function(number)
	{
		this.set(this.KEY.TODO_TASKS_COUNT, number);
	},
	
	decreaseUnHandTaskCount: function()
	{
		var count = this.getTodoTasksCount();
		count --;
		this.setTodoTasksCount(count);
	},
	increaseUnHandTaskCount: function()
	{
		var count = this.getTodoTasksCount();
		count ++;
		this.setTodoTasksCount(count);
	},
	
};