/*******************************************************************************
 * 本地数据库管理
 * 
 * @author lijinrui
 * @version 1.0
 ******************************************************************************/
var DataManager = function()
{
	/**
	 * 数据库
	 */
	this.db = new DataBase();

	/**
	 * 数据库名
	 */
	this.DB_NAME = "icube_sams.db";
	
	this.setUser=function(userId){
		this.DB_NAME=userId+"sams.db";
	}

	/**
	 * 打开数据库
	 */
	this.openDataBase = function()
	{
		var t = this.db.db_open(this.DB_NAME, true);
		return t;
	};

	/**
	 * 关闭数据库
	 */
	this.closeDataBase = function()
	{
		this.db.db_close();
	};

	/**
	 * 判断表是否存在
	 * 
	 * @param table
	 * @returns
	 */
	this.existTable = function(table)
	{
		var t = this.openDataBase();
		if (t == true)
		{
			t = this.db.db_isTableExist(table);
		}
		this.closeDataBase();
		return t;
	};

	/**
	 * 执行SQL语句:CREATE、INSERT、UPDATE 或 DELETE
	 * 
	 * @param sql
	 * @returns
	 */
	this.executeUpdate = function(sql)
	{
		var t = this.openDataBase();
		if (t)
		{
			t = this.db.db_executeUpdate(sql);
		}
		this.closeDataBase();
		return t;
	};

	/**
	 * 执行查询语句
	 * 
	 * @param sql
	 * @returns
	 */
	this.executeQuery = function(sql)
	{
		var t = this.openDataBase();
		var result;
		if (t)
		{
			result = this.db.db_executeQuery(sql);
		}
		this.closeDataBase();
		return result;
	};
};
