/**
 * 简单数据库辅助类
 */
var DBHelper = {
	/**
	 * 连接对象缓存
	 */
	conn : null,
		
	/**
	 * 返回应用关联的DataBase对象，无需手工关闭
	 */
	getAppDB : function(){
		if(null == this.conn){
			this.conn = Util.getAppDb(Util.getAppId()); 
		}
		return this.conn;
	},
	
	/**
	 * 查询，执行select
	 */
	query: function(sql){
		return this.getAppDB().db_executeQuery(sql);
	},
	
	/**
	 * 更新，执行update,delete,insert,create table
	 */
	update: function(sql){
		return this.getAppDB().db_executeUpdate(sql);
	},
	
	isTableExist: function(tblName){
		return this.getAppDB().db_isTableExist(tblName);
	},
	
	escapeSqlStr: function(str){
		return str.replace(/'/g, function(chara){
			switch(chara){
				case "'":
					return "''";
			}
		});
	}
};