
/*******************************************************************************
 *客户信息 
 * @author lijinrui
 * 
 ******************************************************************************/
function checkGps() {
	try {
		var opened = Util.getGpsState();
		if (true != opened) {
			alert("发现您没有打开系统GPS，请点击确定，并在系统设置中打开GPS(勾中\"使用GPS卫星\")。", function () {
				Util.startGpsSetting();
			});
		}
	}
	catch (e) {
	}
}
/**
 *重新定位
 */
function restartPos() {
	startPos("postionCallBack", true);
	document.getElementById("gps_status").innerHTML = "定位中<img src='res:image/dingwei.gif' />";
}
function startGpsIfFailed() {
}
/**
 * 定位响应
 */
function postionCallBack(msgType, data) {
	if (msgType == _MSG_POS_GPS || msgType == _MSG_POS_CELL) {
		$("dealer.location").value = data.pos;
		$("gps_status").innerHTML = "正在获取位置信息<img src='res:image/dingwei.gif' />";
	} else {
		if (msgType == _MSG_GPS_CITY || msgType == _MSG_CELL_CITY) {
			$("gps_status").innerHTML = data.addr;
			$("dealer.locationDesc").value = data.addr;
		} else {
			if (msgType == _MSG_ERROR_CITY) {
				$("gps_status").innerHTML = "未知[" + data.pos + "]";
				$("dealer.locationDesc").value = data.addr;
			} else {
				if (msgType == _MSG_FAIL_CELL) {
					if ($("dealer.location").value.isEmpty()) {
						$("gps_status").innerHTML = "<a style='text-decoration:underline;' href='javascript:restartPos();'>点击这里重新开始定位。</a>";
					}
				}
			}
		}
	}
}
/**
 * 基本信息收缩
 */
function openInfo() {
	var baseDiv = document.getElementById("baseInfo");
	var img = document.getElementById("openImg");
	if (baseDiv.style.display == "none") {
		baseDiv.style.display = "block";
		img.src = "res:image/treeClose.png";
	} else {
		baseDiv.style.display = "none";
		img.src = "res:image/treeOpen.png";
	}
}
/**
 *提交确认
 */
function submitConfirm() {
	if (check()) {
		confirm("是否确认提交信息？", doSubmit, cancelCallBack);
	}
}

function successBack(response){
    if(response.status==200){
		var res=response.responseText.toJSON();
		if(res.flag){
			alert(res.msg,function(){
				 if(res.localId.isNotEmpty()){
					dealerDao.delLocalById(res.localId);
				 }
				 close();
			});
		}else{
			alert(res.msg);
		}
    }
 }
function failBack(response){
     var text = response.objName+"失败，状态为："+response.status;
     Log.i("specialUp",text);
}
/**
 *表单校验
 */
function check() {
	var reg = new Regex();
	var st = getValueByName("dealer.dealerStatus");
	if (st == "1") {
		//客户名称
		var dealerName = getValueByName("dealer.dealerName");
		if (dealerName.isEmpty()) {
			alert("经销商名称不可为空!");
			return;
		}
		if (getSelectedTextById("regionId").isEmpty()) {
			alert("大区不可为空!");
			return;
		}
		if (getSelectedTextById("regionSonId").isEmpty()) {
			alert("区域不可为空!");
			return;
		}
		if (getSelectedTextById("provinceId").isEmpty()) {
			alert("省份不可为空!");
			return;
		}
		if (getSelectedTextById("cityId").isEmpty()) {
			alert("城市不可为空!");
			return;
		}
		//地址
		var dealerAddress = getValueByName("dealer.dealerAddress");
		if (dealerAddress.isEmpty()) {
			alert("地址不可为空!");
			return;
		}
	}
	return true;
}
/**
 * 取消操作
 */
function cancelCallBack() {
}
/**
 *保存
 */
function doSave() {
}
/**
 * 返回
 */
function back() {
	close();
}
var treeAreasAction = "http://ICUBE_URL/tss/dealer/treeAreasJson.action";
var tempAreaClass;
function getTreeAreas(areaClass) {
	tempAreaClass = areaClass;
	var fatherAreaId;
	switch (areaClass) {
	  case "2"://根据大区，取区域
		fatherAreaId = getSelectedValueById("regionId");
		break;
	  case "3"://根据区域，取省份
		fatherAreaId = getSelectedValueById("regionSonId");
		break;
	  case "4"://根据省份，取城市
		fatherAreaId = getSelectedValueById("provinceId");
		break;
	  case "5"://根据城市
		fatherAreaId = getSelectedValueById("cityId");
		break;
	}
	if (null != fatherAreaId) {
		Ajax.post(treeAreasAction, {"fatherAreaId":fatherAreaId, "areaClass":areaClass}, onAjaxResponse);
	}
}
/**
 *取城市级别
 */
function getCityClassById() {
	var cityId = getSelectedValueById("cityId");
	if(null!=cityId){
		var url = "http://ICUBE_URL/tss/dealer/cityClassJson.action";
		Ajax.post(url, {ajaxTag:"ajaxTag", "mssCity.cityId":cityId}, getCityClassResponse);
	}
}
/**
 * 取到城市级别
 */
function getCityClassResponse(xhr) {
	var json = xhr.responseText;
	var ret = Ajax.eval(json);
	if(null!=ret){
		$("cityClass").value = ret.cityClass;
	}
}
/**
 * 提交后的ajax响应函数
 */
function onAjaxResponse(xhr) {
	var json = xhr.responseText;
	var ret = Ajax.eval(json);
	var obj;
	switch (tempAreaClass) {
	  case "2":
		obj = $("regionSonId");
		addOptions(obj, ret);
		setTimeout("getSontAreas()", 10);
		break;
	  case "3":
		obj = $("provinceId");
		addOptions(obj, ret);
		setTimeout("getSontAreas()", 10);
		break;
	  case "4":
		obj = $("cityId");
		addOptions(obj, ret);
		setTimeout("getSontAreas()", 10);
		break;
	  case "5":
		obj = $("areaId");
		addOptions(obj, ret);
		setTimeout("getCityClassById()", 10);
		break;
	}
}
/**
 *取下级区域
 */
function getSontAreas() {
	getTreeAreas((parseInt(tempAreaClass) + 1) + "");
}
/**
* 更新下拉选项
* 
* @param obj
* @param nodes
*/
function addOptions(obj, nodes) {
	clearOptions(obj);
	if (null != nodes) {
		if (nodes.length > 0) {
			for (var x=0;x<nodes.length;x++) {
				var key = nodes[x].areaId;
				var value = nodes[x].areaName;
				var option = document.createElement("option");
				option.text = value;
				option.value = key;
				obj.add(option);
			}
			obj.selectedIndex = 0;
		}
	}
}
/**
* 清空下拉选项
* 
* @param obj
*/
function clearOptions(obj) {
	while (obj.length > 0) {
		obj.remove(obj.length - 1);
	}
}
/**
 * type:0 (isAdd: N label, Y select)
 * type:1 (isAdd: N label, Y text) 
 * type:2 (文本) 
 * type:3 (拍照)
 * type:4 (定位)
 * type:5 (多选)
 */
var formXml = "<form>"
			 + "<field name='dealer.dealerId' type = '2'/>" 
			 + "<field name='dealer.dealerStatus' type = '2'/>" 
			 + "<field name='dealer.dealerName' type = '1'/>" 
			 + "<field name='dealer.regionId' type = '0'/>" 
			 + "<field name='dealer.regionSonId' type = '0'/>" 
			 + "<field name='dealer.provinceId' type = '0'/>" 
			 + "<field name='dealer.cityId' type = '0'/>" 
			 + "<field name='dealer.areaId' type = '0'/>" 
			 + "<field name='dealer.dealerCityClass' type = '1'/>" 
			 + "<field name='dealer.dealerAddress' type = '1'/>" 
			 + "<field name='dealer.dealerRemark' type = '2'/>" 
			 + "<field name='dealer.dealerPointLatlon' type = '4'/>" 
			 + "<field name='dealer.dealerPointExplain' type = '4'/>" 
			 + "<field name='attIds' type = '5'/>" 
			 + "</form>";
/**
 * 保存店面信息到本地数据库
 */
function saveToLocal(isAdd) {
	var v = new XMLDocument();
	v.parseXmlText(formXml);
	var form = v.rootElement;
	// 保存时间(id)
	var time = new Date().getTime();
	form.setAttribute("date", time + "");
	form.setAttribute("isAdd", isAdd);
	var fields = form.childNodes;
	var dealerName="";
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var value = "";
		switch (parseInt(type)) {
		  case 0:
			if (isAdd == "Y") {//新增为下接框
				var sx = document.getElementsByName(n)[0];
				if (null != sx) {
					value = sx.selectedIndex;
					for (var j = 0; j < sx.length; j++) {
						var ov = sx.options[j].value;
						var ot = sx.options[j].text;
						var element = v.createElement("option");
						element.setAttribute("value", ov);
						element.setAttribute("text", ot);
						field.appendChild(element);
					}
				} else {
					value = 0;
				}
			} else {
				value = $(n).innerHTML;
			}
			field.setAttribute("value", value);
			break;
		  case 1:
			if (isAdd == "Y") {
				value = getValueByName(n);
			} else {
				value = $(n).innerHTML;
			}
			if(n=='dealer.dealerName'){
				dealerName=value;
			}
			field.setAttribute("value", value);
			break;
		  case 2:
			value = replaceXmlStr(getValueByName(n));
			field.setAttribute("value", value);
			break;
		  case 3:
			value = getValueByName(n);
			field.setAttribute("value", value);
			break;
		  case 4:
			value = getValueByName(n);
			field.setAttribute("value", value);
			break;
		  case 5:
			value = getCheckBoxValeByName(n);
			field.setAttribute("value", value);
			var checks = document.getElementsByName(n);
			if (null != checks) {
				for ( var ck = 0; ck < checks.length; ck++)
				{
					var check = checks[ck];
					var element = v.createElement("option");
					element.setAttribute("value", check.value);
					element.setAttribute("text", check.value.split('|')[1]);
					field.appendChild(element);
				}
			}
			break;
		  default:
			break;
		}
		
	}
	var xml = v.toXml();
	var dealer = new LocalBean();
	dealer.id = time;
	dealer.form = xml;
	dealer.name = dealerName;
	if (isAdd == "Y") {
		dealer.isAdd = 1;
	} else {
		dealer.isAdd = 0;
	}
	var t = dealerDao.saveLocal(dealer);
	if (t) {
		return dealer.id;
	} else {
		return null;
	}
}
/**
 * 更新
 * 
 * @param id
 */
function updateToLocal(id) {
	var dealer = dealerDao.getLocalById(id);
	var v = new XMLDocument();
	var formXml = dealer.form;
	v.parseXmlText(formXml);
	var form = v.rootElement;
	var isAdd = form.getAttribute("isAdd");
	var fields = form.childNodes;
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var value = "";
		switch (parseInt(type)) {
		  case 0:
			if (isAdd == "Y") {//新增为下接框
				var nodes = field.childNodes;
				if (null != nodes) {
					if (nodes.length > 0) {
						for (var x=0;x<nodes.length;x++) {
							field.removeChild(nodes[x]);
						}
					}
				}
				var sx = document.getElementsByName(n)[0];
				if (null != sx) {
					value = sx.selectedIndex;
					for (var j = 0; j < sx.length; j++) {
						var ov = sx.options[j].value;
						var ot = sx.options[j].text;
						var element = v.createElement("option");
						element.setAttribute("value", ov);
						element.setAttribute("text", ot);
						field.appendChild(element);
					}
				} else {
					value = 0;
				}
			} else {
				value = $(n).innerHTML;
			}
			break;
		  case 1:
			if (isAdd == "Y") {
				value = getValueByName(n);
			} else {
				value = $(n).innerHTML;
			}
			break;
		  case 2:
			value = replaceXmlStr(getValueByName(n));
			break;
		  case 3:
			value = getValueByName(n);
			break;
		  case 4:
			value = getValueByName(n);
			break;
		  case 5:
		  	value = getCheckBoxValeByName(n);
			break;
		  default:
			break;
		}
		field.setAttribute("value", value);
	}
	var vxml = v.toXml();
	dealer.form = vxml;
	var t = dealerDao.updateLocal(dealer);
	return t;
}
/*******************************************************************************
 * 经销商信息本地页面接口
 * 
 * @author lijinrui
 * 
 ******************************************************************************/
/**
 * <pre>
 * 根据父窗口id查询经销商信息
 * </pre>
 * 
 * @returns
 */
function getDealerById() {
	var id = window.getParameter("id");
	var dealer = dealerDao.getLocalById(id);
	return dealer;
}
/**
 * 初始化页面
 */
function initPage() {
	var dealer = getDealerById();
	var v = new XMLDocument();
	var formXml = dealer.form;
	v.parseXmlText(formXml);
	// 表单xml结构数据
	var form = v.rootElement;
	var time = form.getAttribute("date");
	var isAdd = form.getAttribute("isAdd");
	var fields = form.childNodes;
	var divcontent = [];
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var value = field.getAttribute("value");
		switch (parseInt(type)) {
		  case 0:
			if (isAdd == "Y") {//新增为下接框
				var sx = document.getElementsByName(n)[0];
				if (null != sx) {
					var nodes = field.childNodes;
					if (null != nodes) {
						if (nodes.length > 0) {
							for (var x=0;x<nodes.length;x++) {
								var v = nodes[x].getAttribute("value");
								var text = nodes[x].getAttribute("text");
								var option = document.createElement("option");
								option.value = v;
								option.text = text;
								sx.add(option);
							}
						}
					}
					if (!value.isEmpty()) {
						sx.selectedIndex = parseInt(value);
					}
				}
			} else {
				$(n).innerHTML = value;
			}
			break;
		  case 1:
			if (isAdd == "Y") {
				var ele = document.getElementsByName(n);
				if (null != ele && ele.length > 0) {
					ele[0].value = value;
				}
			} else {
				$(n).innerHTML = value;
			}
			break;
		  case 2:
			var ele = document.getElementsByName(n);
			if (null != ele && ele.length > 0) {
				ele[0].value = value;
			}
			break;
		  case 3:
			var ele = document.getElementsByName(n);
			if (null != ele && ele.length > 0) {
				ele[0].value = value;
			}
			break;
		  case 4:
			if (null != value && "" != value) {
				divcontent.push("<input type='hidden' name='" + n + "' value='" + value + "'/>");
			}
			break;
		  case 5:
		  	var ele = $(n+"Div");
		  	var attDiv=[];
		  	var nodes = field.childNodes;
			if (null != nodes) {
				if (nodes.length > 0) {
					for (var x=0;x<nodes.length;x++) {
							var v = nodes[x].getAttribute("value");
							var text = nodes[x].getAttribute("text");
							attDiv.push("<input type='checkbox' name='" + n + "' caption='" + text + "' value='" + v + "' style='color:black;' />");
					}
				}
			}
		  	ele.innerHTML=attDiv.join("");
			setCheckValues(n,value);
			break;
		  default:
			break;
		}
	}
	var mdiv = document.getElementById("latDiv");
	var con = divcontent.join("");
	mdiv.innerHTML = con;
}
function updateDealerLocal() {
	var id = window.getParameter("id");
	var t = updateToLocal(id);
	if (t) {
		alert("数据保存成功！");
	} else {
		alert("数据保存失败！");
	}
}
/**
 * 删除
 * 
 */
function delDealerById() {
	confirm("请确认是否删除数据？", delDealerLocalById, cancelCallBack);
}
function delDealerLocalById() {
	var id = window.getParameter("id");
	dealerDao.delLocalById(id);
	close();
}

