/*静态缓存页面更新*/

/*
{   "c":"wefadtwr2234",
	"f":[
			{
				"n":"css/abcd.css",
				"t":"0",
				"u":"",
				"v":"000002"
			},
			{
				"n":"page/abc.xhtml",
				"t":"1",
				"u":"abc.action?pageId=abc",
				"v":"00001"
			},
			{
				"n":"page/abcd.xhtml",
				"t":"2",
				"u":"abc.action?pageId=abcd",
				"v":"1.0.0.1@V5"
			}
	    ]
}
*/

/*定义全局变量*/
var db = null;			//数据库对象
//var xmlHttp = null; 	//XMLHttpRequest对象


/**
 * 数据库创建
 *
 * dbName     数据库名称 		    res:./iMobiiCache.db	
 * tableName  表名称 			    fileCache	
 * parameter  创建数据库表属性。[属性名称，属性类型，关键词][fileName,TEXT,PRIMARY KEY]
*/
function createDB(dbName,tableName,parameter){
	db = new DataBase();		
	var iMobiiDB = db.db_open(dbName,true);		//打开数据库，若不存在则创建。
	//判断表是否存在，若不存在则创建
	var createRlt = false;
	if(iMobiiDB == true){
		var isTableExist = db.db_isTableExist(tableName);
		if(isTableExist == false){			
			if(parameter != null && parameter != ""){
				var createTableSql = "create table " + tableName + " " + parameter;
				createRlt = db.db_executeUpdate(createTableSql);
			}else{
				alert("创建参数缺失！");
			}			
		}
	}else{
		alert("数据库打开失败！");
	}
	db.db_close();
	return createRlt;
}

/**
 * 数据库表查询
 *
 * dbName     数据库名称 		    res:./iMobiiCache.db	
 * tableName  表名称 			    fileCache	
 * rltParameter 结果字段			fileName,version
 * conParamete 条件字段			fileName='page/abc.xhtml'
*/
function queryDB(dbName,tableName,rltParameter,conParameter){
	db = new DataBase();	
	db.db_open(dbName,false);
	var result = false;
	if(rltParameter != null && rltParameter != ""){
		var sql = "select " + rltParameter + " from " + tableName;
		if(conParameter != null && conParameter != ""){
			sql += " where " + conParameter;
		}
		result = db.db_executeQuery(sql);		
	}else{
		alert("查询结果参数缺失！");
	}	
	db.db_close;
	return result;
}

/**
 * 数据库表新增
 * dbName		数据库名称
 * tableName	表名称
 * parameters	表字段
 * paramValue	表字段值
 * 
 * */
function insertDB(dbName,tableName,parameters,paramValues){
	db = new DataBase();	
	var insertRlt = false;
	db.db_open(dbName,false);
	var sql = "insert into " + tableName + " " + parameters + " values " + paramValues;
	insertRlt = db.db_executeUpdate(sql);
	db.db_close();
	return insertRlt;
}

/**
 * 数据库表更新
 * dbName		数据库名称
 * tableName	表名称
 * parameters	表字段
 * conParam		条件字段
 * 
 * */
 function updateDB(dbName,tableName,parameters,conParam){
 	db = new DataBase();	
 	var updateRlt = false;
 	db.db_open(dbName,false);
 	var sql = "update " + tableName + " set " + parameters + " where " + conParam;
 	updateRlt = db.db_executeUpdate(sql);
 	db.db_close();
 	return updateRlt;
 }

/**
 * 数据库表删除
 * dbName		数据库名称
 * tableName	表名称
 * conParam		条件字段
 * 
 * */
function deleteDB(dbName,tableName,conParam){
	db = new DataBase();	
	var deleteRlt = false;
	db.db_open(dbName,false);
	var sql = "delete from " + tableName + " where " + conParam;
	deleteRlt = db.db_executeUpdate(sql);
	db.db_close();
	return deleteRlt;
}



/**
 * 缓存文件更新主函数
*/
//var dbName = "res:./iMobiiCache.db";	//定义数据库名称
var dbName = "iMobiiCache.db";			//数据库名称

function fileCacheMain(){
	
	
	
	/*创建文件缓存状态码表
	//var dbName = "iMobiiCache.db";			//数据库名称
	var tableName = "fileCacheV";			//表名称
	var parameter = "(fileCacheV TEXT)";	//创建表所需参数
	createDB(dbName,tableName,parameter);
	*/
	/*创建页面缓存信息表
	//var dbName = "iMobiiCache.db";
	tableName = "fileCache";		//定义表名称
	parameter = "(fileName TEXT PRIMARY KEY, fileType INTEGER, url TEXT,version TEXT, updateState TEXT)";
	createDB(dbName,tableName,parameter);
	*/
	
	
	/*获取客户端本地文件缓存状态码*/
	var cacheCode = "";
	var codeRlt = queryDB(dbName,"fileCacheV","fileCacheV","");
	if(codeRlt != false){
		if(codeRlt.length > 1){
			cacheCode = codeRlt[1][0];
			
			/*发起ajax请求，获取缓存文件更新信息*/
			var cacheInfoUrl = "http://IORDER_URL/getCacheInfo.action?cacheCode=" + cacheCode;
			sendAjaxRequest(cacheInfoUrl,"get",fileCacheUpdate,"","");
		}
	}else{
		alert("查询失败！");
		return false;
	}		
}

/**
 * 发起ajax请求
 * url	       	 请求地址
 * requestType   请求类型：get/post
 * callBack   	 回调函数名称
 * parameters 	 post请求时提交参数
 * transferParam 需要传递到回调函数中的参数
*/
function sendAjaxRequest(url,requestType,callBack,parameters,transferParam){
	/*创建XmlHttpObjject请求对象*/
	xmlHttp = new XMLHttpRequest();
	/*readyState属性改变时的回调函数*/
	if(transferParam != null && transferParam != ""){
		xmlHttp.onreadystatechange = callBack(xmlHttp,transferParam); 
	}else{
		xmlHttp.onreadystatechange = callBack(xmlHttp);
	}
	
	/*发送HTTP请求*/
	if(requestType == "post"){
		xmlHttp.setRequestHeader("Content-Type","application/x-www-form-urlencoded; charset=utf-8");
		xmlHttp.open(requestType,url,true);
		xmlHttp.send(parameters);
	}else{
		xmlHttp.open(requestType,url,true);
		xmlHttp.send();
	}
}

/**
 * 服务端相应json数据处理

*/
//function fileCacheUpdate(xmlHttp){
function fileCacheUpdate(){

	eval();  //防止symbian/mobile客户端崩溃
	/*
	if(xmlHttp.status == 200){
		if(xmlHttp.readyState == 4){
	*/
		
			/*服务端返回json数据*/
			/*	var insertSql = "insert into fileCache (version,fileName,url) values ('1.0.0.1@V5_abc.xhtml','page/abc.xhtml','http: //192.168.100.209:6020/iMobii/abc.action')";
				var updateSql = "update fileCache set version='1.0.0.2@V5_abc.xhtml',url='http: //192.168.100.209:6020/iMobii/abc.action' where fileName='abc.xhtml')";	
			*/	
			var returnCache = '({"c":"wefadtwr2234","f":[{"n":"css/abcd.css","t":"0","u":"","v":"000002"},{"n":"page/abc.xhtml","t":"1","u":"abc.action?pageId=abc","v":"00001"},{"n":"page/abcd.xhtml","t":"2","u":"abc.action?pageId=abcd","v":"1.0.0.1@V5"}]})';
			//var returnCache = '({"c":"0"})';
			
			
			//var returnCache = xmlHttp.responseText;
			var returnCaches = eval(returnCache);
			var fileCacheV = returnCaches.c;
			
			if(fileCacheV != 0){	//缓存更新标记位不为零，说明文件缓存有更新
				fileCache = returnCaches.f;		//ajax回调函数中传递的参数不能用var定义
				var returnFileNames = "";		//服务端返回的fileName集合
				
				var mobileOs = Util.getOs();	//获取手机操作系统类型
				var screenWidth = Util.getScreenWidth();	//获取屏幕宽度
				var screenHeight = Util.getScreenHeight();	//获取屏幕高度		
				
				for(i=0;i<fileCache.length;i++){
					
					/*判断客户端数据库表fileCache中存在此条缓存信息*/
					var rltParameter = "fileName,version";						//查询结果字段
					var conParameter = "fileName='" + fileCache[i].n + "'";		//查询条件
					var queryRlt = queryDB(dbName,"fileCache",rltParameter,conParameter);
					
					if(queryRlt != false){
						
						if(fileCache[i].t == 0){   //页面类型为其余资源
							
							if(queryRlt.length >1){		//客户端数据库表存在对应缓存信息
								if(fileCache[i].v != queryRlt[1][1]){	//version不同，说明此条缓存信息有更新
									
									fileCache[i].sqlType = 1;		//数据库操作类型，1为更新，0为新增
									fileCache[i].os = mobileOs;
									fileCache[i].screenWidth = screenWidth;
									fileCache[i].screenHeight = screenHeight;
									
									updateFileCache(fileCache[i]);		//更新缓存文件：新文件下载、数据库信息更新。
								}
							}else{						//客户端数据库表不存在对应缓存信息				
								
								fileCache[i].slqType = 0;
								fileCache[i].os = mobileOs;
								fileCache[i].screenWidth = screenWidth;
								fileCache[i].screenHeight = screenHeight;
								
								updateFileCache(fileCache[i]);								
							}
									
						}else{		//页面类型为静态页面
							if(queryRlt.length >1){
								if(fileCache[i].v != queryRlt[1][1]){
									fileCache[i].sqlType = 1;
									updateDBCache(fileCache[i]);		//数据库信息更新
								}
							}else{
								fileCache[i].sqlType = 0;
								updateDBCache(fileCache[i]);
							}
						}
					}else{
						alert("查询失败！");
						return false;
					}			
					
					returnFileNames = returnFileNames + "'" + fileCache[i].n + "',";
												
				}
				if(returnFileNames.indexOf(",") > 0){
					returnFileNames = returnFileNames.substr(0,returnFileNames.length-1);
				}
				
				var rltParameter = "fileName";
				var conParameter = "fileName not in (" + returnFileNames + ")";
				var delParameter = queryDB(dbName,"fileCache",rltParameter,conParameter);		//获取需要删除的缓存信息文件名
				if(delParameter != false){
					if(delParameter.length >1){
						deleteFileCache(delParameter);		//删除不再需要的本地缓存文件，数据数据库中对应的数据。
					}
				}else{
					alert("查询失败！");
					return false;
				}
			}

/*
		}
	}else if(xmlHttp.status == 500){
		alert("内部服务器错误！");
	}else if(xmlHttp.status == 404){
		alert("请求地址错误！");
	}
*/
	
}

/**
 * 更新缓存文件及数据库信息
*/
function updateFileCache(fileCache){
	
	
	//http://IORDER_URL/downloadFile.action?fileName=page/abc.xhtml&fileType=1
	var downloadUrl = "http://IORDER_URL/downloadFile.action?fileName=" + fileCache.n + "&fileType=" + fileCache.t + "&os=" + fileCache.os + "&screenWidth=" + fileCache.screenWidth + "&screenHeight=" + fileCache.screenHeight;
	sendAjaxRequest(downloadUrl,"get",downloadFileBack,"",fileCache);		//发起ajax请求，下载文件
}

/**
 * 下载文件回调函数处理 
*/
function downloadFileBack(xmlHttp,fileCache){
	
	if(xmlHttp.status == 200){
		if(xmlHttp.readyState == 4){
			var filePath = "res:./" + fileCache.n;
			var isSuccess = xmlHttp.responseToFile(filePath);		//将下载的文件流写入本地文件
			if(isSuccess){
				
				updateDBCache(fileCache);		//数据库缓存信息更新
				
			}else{
				alert("文件下载失败！");
			}
		}
	}else if(xmlHttp.status == 500){
		alert("内部服务器错误！");
	}else if(xmlHttp.status == 404){
		alert("请求地址错误！");
	}
}

/**
 * 数据库缓存信息更新
 * */
function updateDBCache(fileCache){
	
	if(fileCache.sqlType == 0){		//缓存文件为新增
		
		var parameters = "(fileName,fileType,url,version,updateState)";
		var paramValues = "('" + fileCache.n + "','" + fileCache.t + "','" + fileCache.u + "','" + fileCache.v + "',0)";					
		var insertRlt = insertDB(dbName,"fileCache",parameters,paramValues);	//插入数据库表
		if(insertRlt == false){
			alert("缓存文件信息数据库新增失败！");
			return false;
		}
			
	}else if(fileCache.sqlType == 1){		//缓存文件为更新
		
		var parameters = "version='" + fileCache.v + "',updateState=0";
		var conParam = "fileName='" + fileCache.n + "'";
		var updateRlt = updateDB(dbName,"fileCache",parameters,conParam);
		if(updateRlt == false){
			alert("缓存文件信息数据库更新失败!");
			return false;
		}
	}
}

/**
 * 删除不再需要的本地缓存文件，数据数据库中对应的数据。
 * 
 * */
function deleteFileCache(delParameter){
	for(i=1;i<delParameter.length;i++){
		var filePath = "res:./" + delParameter[i];
		var cacheFile = new File(filePath,false);
		var isSuccess = cacheFile.deleteFile();		//删除本地缓存文件
		if(isSuccess){
			var conParam = "fileName='" + delParameter[i] + "'";
			var delRlt = deleteDB(dbName,"fileCache",conParam);				//删除数据库中文件信息
			if(delRlt == false){
				alert("缓存文件信息数据库删除失败！");
				return false;
			}
		}else{
			alert("文件删除失败！");
			return false;
		}
	}
}		






/**
 * 页面请求时统一执行的方法
 * url	页面请求的网络地址
 * target 打开页面方式：_self/_blank
 * */
function pageLoad(url,target){
	var isNewWindow = true;
	if(target == "_self"){
		isNewWindow = false;
	}
	var compareUrl = "";
	var parameters = "";						//页面请求的动态参数
	if(url.indexOf("&split=split") > 0){		//判断有无动态参数
		var urls = url.split("&split=split");
		compareUrl = urls[0];					//有动态参数，获取除去动态参数后的url
		
		var urlss = url.split("?");				//获取需要传递的参数，进行base64编码
		parameters = "parameters=" + Util.base64Encode(urlss[1]);
	}else{
		compareUrl = url;
	}
	var rltParameter = "fileName,fileType,updateState";
	var conParameter = "url='" + compareUrl + "'";
	var queryRlt = queryDB(dbName,"fileCache",rltParameter,conParameter);		//查询客户端数据库中有无url对应的本地文件信息
	if(queryRlt != false){
		if(queryRlt.length > 1){		//检索到信息，url对应页面有本地缓存
			if(queryRlt[1][2] == 1){	//updateState为1，缓存页面已更新
				window.open("res:" + queryRlt[1][0],isNewWindow,false,"",parameters);
			}else{						//updateState为0，缓存页面未更新				
				
				queryRlt[1][3] = isNewWindow;
				queryRlt[1][4] = parameters;
				queryRlt[1][5] = Util.getOs();
				queryRlt[1][6] = Util.getScreenWidth();
				queryRlt[1][7] = Util.getScreenHeight();
				
				updateFileCacheSP(queryRlt);		//更新缓存文件及数据库信息，打开本地页面		
			}	
		}else{							//未检索到信息，url对应页面无本地缓存信息。
			url = "http://IORDER_URL/" + url;					
			window.open(url,isNewWindow);	//打开请求页面
		}
	}else{
		alert("查询失败！");
		return false;
	}	
}

/**
 * 更新缓存文件及数据库信息，静态页面请求时
*/
function updateFileCacheSP(fileCache){
	//http://IORDER_URL/downloadFile.action?fileName=page/abc.xhtml&fileType=1
	var downloadUrl = "http://IORDER_URL/downloadFile.action?fileName=" + fileCache[1][0] + "&fileType=" + fileCache[1][1] + "&os=" + fileCache[1][5] + "&screenWidth=" + fileCache[1][6] + "&screenHeight=" + fileCache[1][7];
	sendAjaxRequest(downloadUrl,"get",downloadFileBackSP,"",fileCache);		//发起ajax请求，下载文件
}

/**
 * 下载文件回调函数处理，静态页面请求时
*/
function downloadFileBackSP(xmlHttp,fileCache){
	if(xmlHttp.status == 200){
		if(xmlHttp.readyState == 4){
			var filePath = "res:./" + fileCache[1][0];
			var isSuccess = xmlHttp.responseToFile(filePath);		//将下载的文件流写入本地文件
			if(isSuccess){				
				updateDBCacheSP(fileCache);		//数据库缓存信息更新				
			}else{
				alert("文件下载失败！");
			}
		}
	}else if(xmlHttp.status == 500){
		alert("内部服务器错误！");
	}else if(xmlHttp.status == 404){
		alert("请求地址错误！");
	}
}

/**
 * 数据库缓存信息更新，静态页面请求时
 * */
function updateDBCacheSP(fileCache){	
	var parameters = "updateState=1";
	var conParam = "fileName='" + fileCache[1][0] + "'";
	var updateRlt = updateDB(dbName,"fileCache",parameters,conParam);
	if(updateRlt == true){
		window.open("res:" + fileCache[1][0],fileCache[1][3],false,"",fileCache[1][4]);	//打开本地页面
	}else{
		alert("缓存文件信息数据库更新失败!");
		return false;
	}
}




/**
 * 页面控件初始化
 * */
function tagInitialize(){
	var doInitialize = document.getElementById("doInitialize").value;	//获取页面控件初始化标记位的值
	if(doInitialize == 1){	//值为1，表明页面控件需要进行初始化。
		var parameters = window.getParameter("parameters");
		parameters = Util.base64Decode(parameters);
		
		/*发起ajax请求，获取控件初始化信息*/
		var tagUrl = "http://IORDER_URL/getTagInitInfo.action?" + parameters;
		sendAjaxRequest(tagUrl,"get",setTagValue,"","");
	}	
}

/**
 * 页面控件初始化回调函数
 * */
function setTagValue(){
	/*if(xmlHttp.status == 200){
		if(xmlHttp.readyState == 4){
		*/	
			/*服务端返回json数据*/
			var returnCache = '({"i":[{"d":"eqwea23","v":"123"},{"d":"eqwdasf","v":"143"}]})';
			//var returnCache = '({"i":[{"d":"address","v":"新街口"},{"d":"sex","v":"2"},{"d":"hobby","v":"0,2"},{"d":"area","v":"2"},{"d":"note","v":"新街口苏宁电器"},{"d":"hiddenarea","v":"新街口国美电器"},{"d":"dateTag","v":"2011-12-30"},{"d":"timeTag","v":"23:00:30"}]})';
			var returnCaches = eval(returnCache);
			var tagInitialize = returnCaches.i;
						
			for(i=0;i<tagInitialize.length;i++){
				
				var tag = document.getElementsByName(tagInitialize[i].d);		//获取tagId对应控件的控件类型。
				
				if(tag != null && tag != ""){
					if(tag[0].objName == "text"){						//对text控件置值						
						tag[0].value = tagInitialize[i].v;						
					}else if(tag[0].objName == "hidden"){			//对hidden控件置值
						tag[0].value = tagInitialize[i].v;
					}else if(tag[0].objName == "date"){				//对日期控件置值
						tag[0].value = tagInitialize[i].v;
					}else if(tag[0].objName == "time"){				//对时间控件置值
						tag[0].value = tagInitialize[i].v;
					}else if(tag[0].objName == "radio"){			//对radio控件置值					 	
					 	for(j=0;j<tag.length;j++){
					 		if(tag[j].value == tagInitialize[i].v){
					 			tag[j].checked = true;
					 		}
					 	}					 	
					}else if(tag[0].objName == "checkbox"){		//对checkbox控件置值
						var tagValue = "," + tagInitialize[i].v + ",";
						for(j=0;j<tag.length;j++){
							if(tagValue.indexOf("," + tag[j].value + ",") >= 0){
								tag[j].checked = true;
							}
						}						
					}else if(tag[0].objName == "select"){			//对select控件置值
						 for(j=0;j<tag[0].length;j++){
						 	if(tag[0].options[j].value == tagInitialize[i].v){
						 		tag[0].options[j].selected = true;
						 	}
						 }						
					}else if(tag[0].objName == "textarea"){		//对textarea控件置值
						tag[0].value = tagInitialize[i].v;							
					}else if (tag[0].objName == "camera"){			//对camera控件置值
						
						
					}
				}									
			}
			
			
		/*}
	}else if(xmlHttp.status == 500){
		alert("内部服务器错误！");
	}else if(xmlHttp.status == 404){
		alert("请求地址错误！");
	}*/
}













