/**
 * @author lijinrui
 */
var Regex = function()
{
	this.intege = "^-?[1-9]\\d*$"; // 整数
	this.intege1 = "^[1-9]\\d*$"; // 正整数
	this.intege2 = "^-[1-9]\\d*$"; // 负整数
	this.num = "^([+-]?)\\d*\\.?\\d+$"; // 数字
	this.num1 = "^[1-9]\\d*|0$"; // 正数（正整数 + 0）
	this.num2 = "^-[1-9]\\d*|0$"; // 负数（负整数 + 0）
	this.decmal = "^([+-]?)\\d*\\.\\d+$"; // 浮点数
	this.decmal1 = "^[1-9]\\d*.\\d*|0.\\d*[1-9]\\d*$"; // 正浮点数
	this.decmal2 = "^-([1-9]\\d*.\\d*|0.\\d*[1-9]\\d*)$"; // 负浮点数
	this.decmal3 = "^-?([1-9]\\d*.\\d*|0.\\d*[1-9]\\d*|0?.0+|0)$"; // 浮点数
	this.decmal4 = "^[1-9]\\d*.\\d*|0.\\d*[1-9]\\d*|0?.0+|0$";// 非负浮点数(正浮点数+0)
	this.decmal5 = "^(-([1-9]\\d*.\\d*|0.\\d*[1-9]\\d*))|0?.0+|0$";// 非正浮点数(负浮点数+0)
	this.email = "^\\w+((-\\w+)|(\\.\\w+))*\\@[A-Za-z0-9]+((\\.|-)[A-Za-z0-9]+)*\\.[A-Za-z0-9]+$"; // 邮件
	this.color = "^[a-fA-F0-9]{6}$"; // 颜色
	this.url = "^http[s]?=\\/\\/([\\w-]+\\.)+[\\w-]+([\\w-./?%&=]*)?$"; // url
	this.chinese = "^[\\u4E00-\\u9FA5\\uF900-\\uFA2D]+$"; // 仅中文
	this.ascii = "^[\\x00-\\xFF]+$"; // 仅ACSII字符
	this.zipcode = "^\\d{6}$"; // 邮编
	this.mobile = "^\\d{0,15}$"; // 手机
	this.ip4 = "^(\\d{1;2}|1\\d\\d|2[0-4]\\d|25[0-5]).(\\d{1;2}|1\\d\\d|2[0-4]\\d|25[0-5]).(d{1;2}|1\\d\\d|2[0-4]\\d|25[0-5]).(\\d{1;2}|1\\d\\d|2[0-4]\\d|25[0-5])$"; // ip地址
	this.notempty = "^\\S+$"; // 非空
	this.picture = "(.*)\\.(jpg|bmp|gif|ico|pcx|jpeg|tif|png|raw|tga)$"; // 图片
	this.rar = "(.*)\\.(rar|zip|7zip|tgz)$"; // 压缩文件
	this.date = "^\\d{4}(\\-|\\/|\.)\\d{1;2}\\1\\d{1;2}$"; // 日期
	this.qq = "^[1-9]*[1-9][0-9]*$"; // QQ号码
	this.tel = "^\s*[0-9| |-]+\s*$"; // 国内电话
	this.username = "^\\w+$"; // 用来用户注册。匹配由数字、26个英文字母或者下划线组成的字符串
	this.letter = "^[A-Za-z]+$"; // 字母
	this.letter_u = "^[A-Z]+$"; // 大写字母
	this.letter_l = "^[a-z]+$"; // 小写字母
	this.idcard = "^[1-9]([0-9]{14}|[0-9]{17})$"; // 身份证

	// 身份证严格验证
	this.aCity =
	{
		11 : "北京",
		12 : "天津",
		13 : "河北",
		14 : "山西",
		15 : "内蒙古",
		21 : "辽宁",
		22 : "吉林",
		23 : "黑龙江",
		31 : "上海",
		32 : "江苏",
		33 : "浙江",
		34 : "安徽",
		35 : "福建",
		36 : "江西",
		37 : "山东",
		41 : "河南",
		42 : "湖北",
		43 : "湖南",
		44 : "广东",
		45 : "广西",
		46 : "海南",
		50 : "重庆",
		51 : "四川",
		52 : "贵州",
		53 : "云南",
		54 : "西藏",
		61 : "陕西",
		62 : "甘肃",
		63 : "青海",
		64 : "宁夏",
		65 : "新疆",
		71 : "台湾",
		81 : "香港",
		82 : "澳门",
		91 : "国外"

	};

	/**
	 * 是否是邮箱
	 */
	this.isEmail = function(email)
	{
		var a = this.test(this.email, email);
		return a;
	};
	/**
	 * 是否是电话
	 */
	this.isTel = function(tel)
	{
		var a = this.test(this.tel, tel);
		return a;
	};
	/**
	 * 是否是邮编
	 */
	this.isZipcode = function(zipcode)
	{
		var a = this.test(this.zipcode, zipcode);
		return a;
	};
	/**
	 * 是否是手机
	 */
	this.isMobile = function(mobile)
	{
		var a = this.test(this.mobile, mobile);
		return a;
	};
	/**
	 * 是否中文字符
	 */
	this.isChinese = function(str)
	{
		var a = this.test(this.chinese, str);
		return a;
	};

	/**
	 * 是否数字
	 */
	this.isNum = function(num)
	{
		var a = this.test(this.num, num);
		return a;
	};

	/**
	 * 是否整数
	 */
	this.isIntege = function(intege)
	{
		var a = this.test(this.intege, intege);
		return a;
	};
	/**
	 * 是否正整数
	 */
	this.isPIntege = function(intege)
	{
		var a = this.test(this.intege1, intege);
		return a;
	};
	/**
	 * 是否负整数
	 */
	this.isNIntege = function(intege)
	{
		var a = this.test(this.intege2, intege);
		return a;
	};
	/**
	 * 
	 */
	this.test = function(regStr, str)
	{
		return new RegExp(regStr).test(str);
	};

};
