/*******************************************************************************
 * 特殊记录上报
 * @author lijinrui
 *
 ******************************************************************************/
/**
 *提交确认
 */
function submitConfirm() {
	if (check()) {
		confirm("是否确认提交信息", doSubmit, cancelCallBack);
	}
}

function doSubmit() {
	var form = document.getElementById("submitForm");
	form.action = "http://ICUBE_URL/tss/specialup/specialUpSave.action";
	form.isHideProcess = false;
	form.success = successBack;
    form.fail = failBack;
	form.submit();
}

function successBack(response){
    if(response.status==200){
		var res=response.responseText.toJSON();
		if(res.flag){
			alert(res.msg,function(){
				 if(res.localId.isNotEmpty()){
					 specialUpDao.delLocalById(res.localId);
				 }
				 close();
			});
		}else{
			alert(res.msg);
		}
    }
 }
function failBack(response){
     var text = response.objName+"失败，状态为："+response.status;
     Log.i("specialUp",text);
}

/**
 *表单校验
 */
function check() {
	var reg = new Regex();
	var st = getValueByName("customer.customerState");
	var customerName = getValueByName("specialUp.customerName");
	if (customerName.isEmpty()) {
		alert("拜访单位不可为空!");
		return false;
	}
	if($("vistPhoto").length<1){//为空
		alert("拜访单位照片不可为空!");
		return false;
	}

	var type = getValueByName("specialUp.visitType");
	if (type == '1') {
		var trainPeoples = $("trainPeoples").value;
		if (!trainPeoples.isEmpty()) {//为空
			if (trainPeoples.length > 8) {
				alert("培训人数限制长度为8位！");
				return false;
			}
		}
	}
	return true;
}

/**
 *保存
 */
var tempId = "";
function doSave() {
	var pid = window.getParameter("id");
	if (pid.isEmpty() && tempId.isEmpty()) {
		tempId = saveToLocal();
		if (!tempId.isEmpty()) {
			alert("保存成功！");
		} else {
			alert("保存失败！");
		}
	} else {
		if (tempId.isEmpty()) {
			tempId = pid;
		}
		var t = updateToLocal(tempId);
		if (t) {
			alert("保存成功！");
		} else {
			alert("保存失败！");
		}
	}
	$("localId").value = tempId;
}

/**
 * 取消操作
 */
function cancelCallBack() {
}

/**
 * 返回
 */
function back() {
	close();
}

/**
 * type:0 (hiden)
 * type:1 (text)
 * type:2 (radio)
 * type:3 (check)
 * type:4 (select)
 * type:5 (拍照)
 */
var formXml = "<form>" + "<field name='specialUp.createTime' type = '0' formtype='0'/>" + "<field name='specialUp.visitType' type = '0' formtype='0'/>" + "<field name='specialUp.customerName' type = '1' formtype='0'/>" + "<field name='specialUp.customerAddress' type = '1' formtype='0'/>" + "<field name='specialUp.vistiedName' type = '1' formtype='0'/>" + "<field name='vistPhoto' type = '5' formtype='0'/>" + "<field name='specialUp.wholeImage' type = '2' formtype='1'/>" + "<field name='specialUp.stockIsStandard' type = '2' formtype='1'/>" + "<field name='stockPhoto' type = '5' formtype='1'/>" + "<field name='specialUp.trainType' type = '4' formtype='1'/>" + "<field name='specialUp.trainPeoples' type = '1' formtype='1'/>" + "<field name='specialUp.trainContent' type = '1' formtype='1'/>" + "<field name='specialUp.userNeed' type = '1' formtype='2'/>" + "<field name='specialUp.visitFeedback' type = '1' formtype='2'/>" + "<field name='dealerVisitPhoto' type = '5' formtype='0'/>" + "<field name='specialUp.dealerVisitAim' type = '1' formtype='3'/>" + "<field name='specialUp.otherVisitResult' type = '1' formtype='3'/>" + "<field name='specialUp.otherContent' type = '1' formtype='0'/>" + "<field name='otherPhoto' type = '5' formtype='0'/>" + "</form>";
/**
 * 保存店面信息到本地数据库
 */
function saveToLocal() {
	var v = new XMLDocument();
	v.parseXmlText(formXml);
	var form = v.rootElement;
	// 保存时间(id)
	var time = new Date().getTime();
	form.setAttribute("date", time + "");
	var isAdd = getValueByName("specialUp.visitType");
	form.setAttribute("isAdd", isAdd);
	var custName = "";
	var fields = form.childNodes;
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var formtype = field.getAttribute("formtype");
		var value = "";
		if (formtype == 0 || formtype == isAdd) {
			switch (parseInt(type)) {
			case 0:
			case 1:
				value = getValueByName(n);
				break;
			case 2:
				value = getRadioValeByName(n);
				break;
			case 3:
				value = getCheckBoxValeByName(n);
				break;
			case 4:
				value = getSelectedValueByName(n);
				break;
			case 5:
				if (null != $(n)) {
					value = $(n).foldername;
				}
				break;
			default:
				break;
			}
		}
		field.setAttribute("value", value);
	}

	var xml = v.toXml();
	var specialUp = new LocalBean();
	specialUp.id = time;
	specialUp.form = xml;
	specialUp.name = getSpecialUpTypeName(isAdd);
	specialUp.isAdd = getValueByName("specialUp.visitType");
	var t = specialUpDao.saveLocal(specialUp);
	if (t) {
		return specialUp.id + "";
	} else {
		return "";
	}
}

function getSpecialUpTypeName(type) {
	switch(type) {
	case '1':
		return "巡店";
		break;
	case '2':
		return "客户拜访";
		break;
	case '3':
		return "经销商拜访";
		break;
	case '4':
		return "其他";
		break;
	}
}

/**
 * 更新
 *
 * @param id
 */
function updateToLocal(id) {
	var specialUp = specialUpDao.getLocalById(id);
	var v = new XMLDocument();
	var formXml = specialUp.form;
	v.parseXmlText(formXml);
	var form = v.rootElement;
	var isAdd = form.getAttribute("isAdd");
	var fields = form.childNodes;
	var custName = "";
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var formtype = field.getAttribute("formtype");
		var value = "";
		if (formtype == 0 || formtype == isAdd) {
			switch (parseInt(type)) {
			case 0:
			case 1:
				value = getValueByName(n);
				break;
			case 2:
				value = getRadioValeByName(n);
				break;
			case 3:
				value = getCheckBoxValeByName(n);
				break;
			case 4:
				value = getSelectedValueByName(n);
				break;
			case 5:
				if (null != $(n)) {
					value = $(n).foldername;
				}
				break;
			default:
				break;
			}
		}
		field.setAttribute("value", value);
	}
	var vxml = v.toXml();
	specialUp.form = vxml;
	var t = specialUpDao.updateLocal(specialUp);
	return t;
}

/*******************************************************************************
 * @author lijinrui
 ******************************************************************************/
/**
 * 根据父窗口id查询客户信息
 */
function getSpecialUpById() {
	var id = window.getParameter("id");
	var specialUp = specialUpDao.getLocalById(id);
	return specialUp;
}

function init() {
	// 保存时间(id)
	var time = new Date();
	$("createTime").value = time;
}

/**
 * 初始化页面
 */
function initPage() {
	var id = window.getParameter("id");
	if (id.isEmpty()) {
		return;
	}
	$("localId").value = id;
	var specialUp = getSpecialUpById();
	var v = new XMLDocument();
	var formXml = specialUp.form;
	v.parseXmlText(formXml);
	// 表单xml结构数据
	var form = v.rootElement;
	var time = form.getAttribute("date");
	var isAdd = form.getAttribute("isAdd");
	var fields = form.childNodes;
	var divcontent = [];
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var value = field.getAttribute("value");
		var formtype = field.getAttribute("formtype");
		var ele = document.getElementsByName(n);
		if (formtype == 0 || formtype == isAdd) {
			switch (parseInt(type)) {
			case 0:
				ele[0].value = value;
				break;
			case 1:
				ele[0].value = value;
				break;
			case 2:
				setRadioValue(n, value);
				break;
			case 3:
				setCheckValues(n, value);
				break;
			case 4:
				setSelectedValueByName(n, value);
				break;
			case 5:
				if (null != $(n)) {
					var en = $(n).name;
					if (!value.isEmpty()) {
						//divPic.innerHTML="<input name='"+en+"' id='"+n+"' value='"+ value+"' type='camera' mode='still' pwidth='850' class='txtWidth' path='sys:data/pic' />";
						document.getElementById(n).load(value);
					}
				}
				break;
			default:
				break;
			}
		}
	}
}

function updateCustomerLocal() {
	var id = window.getParameter("id");
	var t = updateToLocal(id);
	if (t) {
		alert("\u6570\u636e\u4fdd\u5b58\u6210\u529f\uff01");
	} else {
		alert("\u6570\u636e\u4fdd\u5b58\u5931\u8d25\uff01");
	}
}

function back() {
	if ("" == tempId) {
		confirm("是否保存表单？", saveForm, close);
	} else {
		close();
	}
}

function saveForm() {
	if (tempId.isEmpty()) {
		tempId = saveToLocal();
		if (!tempId.isEmpty()) {
			alert("保存成功！", close);
		} else {
			alert("保存失败！");
		}
	} else {
		var t = updateToLocal(tempId);
		if (t) {
			alert("保存成功！", close);
		} else {
			alert("保存失败！");
		}
	}
}

/**
 * 删除
 *
 */
function delSpecialUpById() {
	confirm("\u8bf7\u786e\u8ba4\u662f\u5426\u5220\u9664\u6570\u636e\uff1f", delSpecialUpLocalById, cancelCallBack);
}

function delSpecialUpLocalById() {
	var id = window.getParameter("id");
	try {
		delSpecialUpPic(id);
	} catch (e) {
	}
	specialUpDao.delLocalById(id);
	close();
}

function delSpecialUpPic() {
	var specialUp = getSpecialUpById();
	var v = new XMLDocument();
	var formXml = specialUp.form;
	v.parseXmlText(formXml);
	// 表单xml结构数据
	var form = v.rootElement;
	var fields = form.childNodes;
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var type = field.getAttribute("type");
		var value = field.getAttribute("value");
		switch (parseInt(type)) {
			case 5:
	 		delPhotoDir(value);
			break;
		}
	}
}

