
/*******************************************************************************
 * 店面信息接口
 * 
 * @author lijinrui
 * 
 ******************************************************************************/
function checkGps() {
	try {
		var opened = Util.getGpsState();
		if (true != opened) {
			alert("发现您没有打开系统GPS，请点击确定，并在系统设置中打开GPS(勾中\"使用GPS卫星\")。", function () {
				Util.startGpsSetting();
			});
		}
	}
	catch (e) {
	}
}
function restartPos() {
	startPos("postionCallBack", true);
	document.getElementById("gps_status").innerHTML = "定位中<img src='res:image/dingwei.gif' />";
}
function startGpsIfFailed() {
}
function postionCallBack(msgType, data) {
	if (msgType == _MSG_POS_GPS || msgType == _MSG_POS_CELL) {
		$("store.location").value = data.pos;
		$("gps_status").innerHTML = "正在获取位置信息<img src='res:image/dingwei.gif' />";
	} else {
		if (msgType == _MSG_GPS_CITY || msgType == _MSG_CELL_CITY) {
			$("gps_status").innerHTML = data.addr;
			$("store.locationDesc").value = data.addr;
		} else {
			if (msgType == _MSG_ERROR_CITY) {
				$("gps_status").innerHTML = "未知[" + data.pos + "]";
				$("store.locationDesc").value = data.addr;
			} else {
				if (msgType == _MSG_FAIL_CELL) {
					if($("store.location").value.isEmpty()){
						document.getElementById("gps_status").innerHTML = "<a style='text-decoration:underline;' href='javascript:restartPos();'>点击这里重新开始定位。</a>";
					}
				}
			}
		}
	}
}
function openInfo() {
	var baseDiv = document.getElementById("baseInfo");
	var img = document.getElementById("openImg");
	if (baseDiv.style.display == "none") {
		baseDiv.style.display = "block";
		img.src = "res:image/treeClose.png";
	} else {
		baseDiv.style.display = "none";
		img.src = "res:image/treeOpen.png";
	}
}


function successBack(response){
    if(response.status==200){
		var res=response.responseText.toJSON();
		if(res.flag){
			alert(res.msg,function(){
				 if(res.localId.isNotEmpty()){
					 delStoreLocalById(res.localId);
				 }
				 close();
			});
		}else{
			alert(res.msg);
		}
    }
 }
function failBack(response){
     var text = response.objName+"失败，状态为："+response.status;
     Log.i("specialUp",text);
}

function check() {
	// id lable 是否必输 长度
	var mapArray = [["area", "使用面积", false, 10, "num"], 
				   ["storeEmail", "邮箱", false, 100, "mail"]];
	var reg = new Regex();
	for (var i = 0; i < mapArray.length; i++) {
		var map = mapArray[i];
		var lable = map[0];
		var lname = map[1];
		var dom = document.getElementById(lable);
		var domPropertyName = "value";
		if (dom) {
			var value = dom[domPropertyName].trim();
			if (value.isEmpty()) {
				if (map[2]) {// 必输
					alert(lname + "不能为空！");
					return false;
				}
			} else {
				// 输入长度
				var vlen = map[3];
				// 格式类型
				var regType = map[4];
				// 长度校验
				if (value.length > vlen) {
					alert(lname + "长度超出" + vlen + "!");
					return false;
				}
				// 数字
				if (regType == "num") {
					if (!reg.isNum(value)) {
						alert(lname + "必须是数字!");
						return false;
					}
				}
				// 正整数
				if (regType == "pIntege") {
					if (!reg.isPIntege(value)) {
						alert(lname + "必须是正整数!");
						return false;
					}
				}
				if (regType == "tel") {
					if (!reg.isTel(value)) {
						alert(lname + "格式不正确!");
						return false;
					}
				}
				if (regType == "fax") {
					if (!reg.isTel(value)) {
						alert(lname + "格式不正确!");
						return false;
					}
				}
				if (regType == "mobile") {
					if (!reg.isMobile(value)) {
						alert(lname + "格式不正确!");
						return false;
					}
				}
				if (regType == "mail") {
					if (!reg.isEmail(value)) {
						alert(lname + "格式不正确!");
						return false;
					}
				}
			}
		}
	}
	return true;
}
function viewPhoto(photoId) {
	var url = "http://ICUBE_URL/tss/photo/viewPhoto.action?photoupload.photoUploadId=" + photoId;
	window.open(url, true, false, "");
}
/**
 * type:0 label 
 * type:1 (文本) 
 * type:2 (拍照)
 * type:3 (定位)
 */
var formXml = "<form>" 
	+ "<field name='store.storeId' type = '1'/>" 
	+ "<field name='store.storeName' type = '0'/>"
	+ "<field name='store.storeCode' type = '0'/>" 
	+ "<field name='store.cityClassName' type = '0'/>" 
	+ "<field name='store.itCityName' type = '0'/>" 
	+ "<field name='store.storeCharacter' type = '0'/>"
	+ "<field name='store.regionName' type = '0'/>" 
	+ "<field name='store.regionSonName' type = '0'/>"
	+ "<field name='store.provinceName' type = '0'/>" 
	+ "<field name='store.cityName' type = '0'/>"
	+ "<field name='store.areaName' type = '0'/>" 
	+ "<field name='store.storeAddress' type = '1'/>"
	+ "<field name='store.storeCentiare' type = '1'/>" 
	+ "<field name='store.storeTel' type = '1'/>" 
	+ "<field name='store.storeFax' type = '1'/>"
	+ "<field name='store.storeEmail' type = '1'/>" 
	+ "<field name='pic_id' type = '2'/>"
	+ "<field name='store.storePointLatlon' type = '3'/>"
	+ "<field name='store.storePointExplain' type = '3'/>" 
	+ "</form>";
/**
 * 保存店面信息到本地数据库
 */
function saveToLocal() {
	var v = new XMLDocument();
	v.parseXmlText(formXml);
	var form = v.rootElement;
	// 保存时间(id)
	var time = new Date().getTime();
	form.setAttribute("date", time + "");
	var fields = form.childNodes;
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var value = "";
		switch (parseInt(type)) {
		  case 0:
			value = $(n).innerHTML;
			break;
		  case 1:
			value = getValueByName(n);
			break;
		  case 2:
			value = $(n).foldername;
			break;
		  case 3:
			value = getValueByName(n);
			break;
		  default:
			break;
		}
		field.setAttribute("value", value);
	}
	var xml = v.toXml();
	var store = new LocalBean();
	store.id = time;
	store.form = xml;
	store.name =$('store.storeName').innerHTML;
	var t = storeDao.saveLocal(store);
	if (t) {
		return store.id;
	} else {
		return null;
	}
}
/**
 * 更新
 * 
 * @param id
 */
function updateToLocal(id) {
	var store = storeDao.getLocalById(id);
	var v = new XMLDocument();
	var formXml = store.form;
	v.parseXmlText(formXml);
	var form = v.rootElement;
	var fields = form.childNodes;
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var value = "";
		switch (parseInt(type)) {
		  case 0:
			value = $(n).innerHTML;
			break;
		  case 1:
			value = getValueByName(n);
			break;
		  case 2:
			value = $(n).foldername;
			break;
		  case 3:
			value = getValueByName(n);
			break;
		  default:
			break;
		}
		field.setAttribute("value", value);
	}
	var vxml = v.toXml();
	store.form = vxml;
	var t = storeDao.updateLocal(store);
	return t;
}
/*******************************************************************************
 * 门店信息本地页面接口
 * 
 * @author lijinrui
 * 
 ******************************************************************************/
/**
 * <pre>
 * 根据父窗口id查询门店信息
 * </pre>
 * 
 * @returns
 */
function getStoreById() {
	var id = window.getParameter("id");
	var store = storeDao.getLocalById(id);
	return store;
}
/**
 * 初始化页面
 */
function initPage() {
	var store = getStoreById();
	var v = new XMLDocument();
	var formXml = store.form;
	v.parseXmlText(formXml);
	// 表单xml结构数据
	var form = v.rootElement;
	var time = form.getAttribute("date");
	var fields = form.childNodes;
	var divcontent = [];
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var value = field.getAttribute("value");
		switch (parseInt(type)) {
		  case 0:
			$(n).innerHTML = value;
			break;
		  case 1:
			var ele = document.getElementsByName(n);
			if (null != ele && ele.length > 0) {
				ele[0].value = value;
			}
			break;
		  case 2:
		     var divPic=$("div_"+n);
		     if(!value.isEmpty()){
		     	$(n).load(value);
		     }
			break;
		  case 3:
		  	if(null!=value&&""!=value){
		  		divcontent.push("<input type='hidden' name='"+ n+"' value='" + value+ "'/>");
		  	}
			break;
		  default:
			break;
		}
	}
	var mdiv = document.getElementById("latDiv");
	var con = divcontent.join("");
	mdiv.innerHTML = con;
};
/**
 * 本地更新确认
 */
function updateStoreConfirm()
{
	var id = window.getParameter("id");
	var t = updateToLocal(id);
	if (t)
	{
		alert("数据保存成功！");
	} else
	{
		alert("数据保存失败！");
	}
};

/**
 * 删除确认
 * 
 */
function delStoreConfirm()
{
	confirm("请确认是否删除数据？",delStoreLocal,cancelCallBack);
};
/**
 * 本地数据删除
 */
function delStoreLocal()
{
	var id = window.getParameter("id");
	delStoreLocalById(id);
	close();
};
function delStoreLocalById(id)
{
	var store = storeDao.getLocalById(id);
	var v = new XMLDocument();
	var formXml = store.form;
	v.parseXmlText(formXml);
	// 表单xml结构数据
	var form = v.rootElement;
	var fields = form.childNodes;
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var type = field.getAttribute("type");
		var value = field.getAttribute("value");
		switch (parseInt(type)) {
		  case 2:
		     if(!value.isEmpty()){
		     	delPhotoDir(value);
		     }
			break;
		  default:
			break;
		}
	}
	storeDao.delLocalById(id);
};

/**
 * 返回到待传页面
 */
function backToWaitUpload()
{
	var url = "http://ICUBE_URL/tss/waitdata/waitupload.action";
	window.open(url, true, false, "", "");
};

