/*******************************************************************************
 * 本地存储接口
 * @author lijinrui
 *
 ******************************************************************************/
var VER = 1.0;

function LocalMap() {
	this.key = null;
	this.value = null;
	/**
	 * 数据库管理
	 */
	this.datamanager = new DataManager();
	this.createTable = function() {
		var t = true;
		if (!this.datamanager.existTable("LOCAL_MAP")) {
			var createSql = "create table LOCAL_MAP (key TEXT,value TEXT)";
			t = this.datamanager.executeUpdate(createSql);
		}
		return t;
	};

	this.put = function(key, value) {
		var t = this.createTable();
		if (t) {
			var v = this.get(key);
			var sql;
			if ('' == v) {
				sql = "insert into LOCAL_MAP(key,value) values(";
				sql += "'" + key + "',";
				sql += "'" + value + "')";
			} else {
				sql = "update LOCAL_MAP ";
				sql += "set value='" + value + "' ";
				sql += "where key='" + key + "'";
			}
			t = this.datamanager.executeUpdate(sql);
		}
		return t;
	}
	this.clear = function() {
		var sql = "delete from LOCAL_MAP";
		this.datamanager.executeUpdate(sql);
	}
	this.get = function(key) {
		var sql = "select value from LOCAL_MAP where key='" + key + "'";
		var result = this.datamanager.executeQuery(sql);
		var v = '';
		if (null != result) {
			var rln = result.length;
			if (rln > 0) {
				for (var i = 1; i < rln; i++) {
					if (i == 1) {
						var rowObj = result[i];
						v = rowObj[0];
						break;
					}
				}
			}
		}
		return v;
	}
}

var localMap = new LocalMap();
/**
 * 本地存储对象
 */
function LocalBean() {
	// 类型
	this.type = 0;
	// 本地存储记录ID
	this.id = null;
	// 表单
	this.form = null;
	//isAdd
	this.isAdd = null;
	//
	this.name = null;
	//
	this.fields = null;
}

/**
 * 本地存储DAO
 */
function LocalBeanDao(type, table) {
	/**
	 * 类型
	 */
	this.type = type;
	/**
	 * 本地存储表
	 */
	this.table = table;
	/**
	 * 数据库管理
	 */
	this.datamanager = new DataManager();
	/**
	 * 创建本地存储
	 */
	this.createTable = function() {
		var t = true;
		if (!this.datamanager.existTable(this.table)) {
			var createSql = "create table " + this.table + "(id TEXT,form TEXT,isAdd Text,name Text,fields Text)";
			t = this.datamanager.executeUpdate(createSql);
		}
		return t;
	};
	/**
	 * 保存数据
	 */
	this.saveLocal = function(localBean) {
		// 如果表已经存在则不会新建表
		var t = this.createTable();
		if (t) {
			var userId = localMap.get('USER_ID');
			var sql = "insert into " + this.table + "(id,form,isAdd,name,fields) values(";
			sql += "'" + localBean.id + "',";
			sql += "'" + localBean.form + "',";
			sql += "'" + localBean.isAdd + "',";
			sql += "'" + localBean.name + "',";
			sql += "'" + userId + "')";
			t = this.datamanager.executeUpdate(sql);
		}
		return t;
	};
	/**
	 * 更新
	 */
	this.updateLocal = function(localBean) {
		var sql = "update " + this.table + " ";
		sql += "set form='" + localBean.form + "',";
		sql += "name='" + localBean.name + "' "
		sql += "where id='" + localBean.id + "'";
		var t = false;
		try {
			t = this.datamanager.executeUpdate(sql);
		} catch (e) {
		}
		return t;
	};
	/**
	 * 查询
	 */
	this.queryLocal = function() {
		var userId = localMap.get('USER_ID');
		var sql = "select id,isAdd,name from " + this.table + " where fields='" + userId + "'";
		;
		var buf = [];
		if (this.createTable()) {
			var result = this.datamanager.executeQuery(sql);
			if (null != result) {
				if (result.length > 1) {
					for (var i = 1; i < result.length; i++) {
						var row = result[i];
						var local = new LocalBean();
						local.type = this.type;
						local.id = row[0];
						local.isAdd = row[1];
						local.name = row[2];
						buf.push(local);
					}
				}
			}
		}
		return buf;
	};
	/**
	 * 根据ID查询
	 */
	this.getLocalById = function(id) {
		var sql = "select id,form,isAdd,name,fields from " + this.table + " where id='" + id + "'";
		var result = this.datamanager.executeQuery(sql);
		var localBean = new LocalBean();
		localBean.type = this.type;
		if (null != result) {
			var rln = result.length;
			if (rln > 0) {
				for (var i = 1; i < rln; i++) {
					if (i == 1) {
						var rowObj = result[i];
						for (var j = 0; j < rowObj.length; j++) {
							var row = rowObj[j];
							switch (j) {
							case 0:
								localBean.id = row + "";
								break;
							case 1:
								localBean.form = row + "";
								break;
							case 2:
								localBean.isAdd = row + "";
								break;
							case 3:
								localBean.name = row + "";
								break;
							case 4:
								localBean.fields = row + "";
								break;
							default:
								break;
							}
						}
						break;
					}
				}
			}
		}
		return localBean;
	};
	/**
	 * 根据ID查询
	 */
	this.getLocalByIsAdd = function(isAdd) {
		var sql = "select id,form,isAdd,name,fields from " + this.table + " where isAdd='" + isAdd + "'";
		var result = this.datamanager.executeQuery(sql);
		var localBean = null;
		if (null != result) {
			var rln = result.length;
			if (rln > 0) {
				for (var i = 1; i < rln; i++) {
					if (i == 1) {
						localBean = new LocalBean();
						localBean.type = this.type;
						var rowObj = result[i];
						for (var j = 0; j < rowObj.length; j++) {
							var row = rowObj[j];
							switch (j) {
							case 0:
								localBean.id = row + "";
								break;
							case 1:
								localBean.form = row + "";
								break;
							case 2:
								localBean.isAdd = row + "";
								break;
							case 3:
								localBean.name = row + "";
								break;
							case 4:
								localBean.fields = row + "";
								break;
							default:
								break;
							}
						}
						break;
					}
				}
			}
		}
		return localBean;
	};
	/**
	 * 删除
	 *
	 * @param id
	 */
	this.delLocalById = function(id) {
		var sql = "delete from " + this.table + " where id='" + id + "'";
		this.datamanager.executeUpdate(sql);
	};
}

// 巡店，巡店DAO
var TYPE_STORE_VISIT = 1;
var storeVisitDao = new LocalBeanDao(TYPE_STORE_VISIT, "LOCAL_STORE_VISIT");

// 店面信息，dao
var TYPE_STORE_INFO = 2;
var storeDao = new LocalBeanDao(TYPE_STORE_INFO, "LOCAL_STORE");

// 客户拜访,客户拜访DAO
var TYPE_CUSTOMER_VISIT = 3;
var customerVisitDao = new LocalBeanDao(TYPE_CUSTOMER_VISIT, "LOCAL_CUSTOMER_VISIT");

// 客户信息,客户信息DAO
var TYPE_CUSTOMER_INFO = 4;
var customerDao = new LocalBeanDao(TYPE_CUSTOMER_INFO, "LOCAL_CUSTOMER");

//经销商拜访,经销商拜访DAO
var TYPE_DEALER_VISIT = 5;
var dealerVisitDao = new LocalBeanDao(TYPE_DEALER_VISIT, "LOCAL_DEALER_VISIT");

//经销商信息,dao
var TYPE_DEALER_INFO = 6;
var dealerDao = new LocalBeanDao(TYPE_DEALER_INFO, "LOCAL_DEALER");

//特殊记录上报
var TYPE_SPECIALUP = 7;
var specialUpDao = new LocalBeanDao(TYPE_SPECIALUP, "LOCAL_SPECIALUP");

//待办任务
var TYPE_TASK = 8;
var taskDao = new LocalBeanDao(TYPE_TASK, "LOCAL_TASK");

/*******************************************************************************
 * 待传报告接口
 *
 * @author lijinrui
 * @version 1.0
 ******************************************************************************/
function WaitUploadDao() {
	this.count = 0;
	/**
	 * 取类型名
	 */
	this.getTypeName = function(type) {
		var typeName = "";
		switch (type) {
		case TYPE_STORE_VISIT:
			typeName = "巡店";
			break;
		case TYPE_STORE_INFO:
			typeName = "门店信息";
			break;
		case TYPE_CUSTOMER_VISIT:
			typeName = "客户拜访";
			break;
		case TYPE_CUSTOMER_INFO:
			typeName = "客户信息";
			break;
		case TYPE_DEALER_VISIT:
			typeName = "经销商拜访";
			break;
		case TYPE_DEALER_INFO:
			typeName = "经销商信息";
			break;
		case TYPE_SPECIALUP:
			typeName = "特殊记录上报";
			break;
		case TYPE_TASK:
			typeName = "待办任务";
			break;
		default:
			break;
		}
		return typeName;
	};
	/**
	 * 查询所有传报告
	 */
	this.getAllUploads = function() {
		var wuArr = new Array();
		var results = [];
		for (var i = 0; i < 8; i++) {
			switch (i) {
			case 0:
				//巡店
				results = storeVisitDao.queryLocal();
				break;
			case 1:
				//门店信息
				results = storeDao.queryLocal();
				break;
			case 2:
				//客户拜访
				results = customerVisitDao.queryLocal();
				break;
			case 3:
				//客户信息
				results = customerDao.queryLocal();
				break;
			case 4:
				//经销商拜访
				results = dealerVisitDao.queryLocal();
				break;
			case 5:
				//经销商信息
				results = dealerDao.queryLocal();
				break;
			case 6:
				//特殊记录上报
				results = specialUpDao.queryLocal();
				break;
			case 7:
				//待办任务
				results = taskDao.queryLocal();
				break;
			default:
				break;
			}
			if (results.length > 0) {
				wuArr = wuArr.concat(results);
			}
		}
		this.count = wuArr.length;
		return wuArr;
	};
	/**
	 * 删除
	 *
	 * @param recordId
	 * @param type
	 */
	this.delUploads = function(local) {
		var id = local.id;
		switch (parseInt(local.type)) {
		case TYPE_STORE_VISIT:
			//巡防
			this.delStoreVisitPic(id);
			break;
		case TYPE_STORE_INFO:
			//门店更新
			this.delStorePic(id);
			storeDao.delLocalById(id);
			break;
		case TYPE_CUSTOMER_VISIT:
			//客户拜访
			try {
				this.delCustomerVisitPic(id);
			} catch (e) {
			}
			customerVisitDao.delLocalById(id);
			break;
		case TYPE_CUSTOMER_INFO:
			//客户
			customerDao.delLocalById(id);
			break;
		case TYPE_DEALER_VISIT:
			//经销商拜访
			try {
				this.delDealerVisitPic(id);
			} catch (e) {
			}
			dealerVisitDao.delLocalById(id);
			break;
		case TYPE_DEALER_INFO:
			//经销商信息
			dealerDao.delLocalById(id);
			break;
		case TYPE_SPECIALUP:
			//特殊记录上报
			try {
				this.delSpecialUpPic(id);
			} catch (e) {
			}
			specialUpDao.delLocalById(id);
			break;
		case TYPE_TASK:
			//经销商信息
			try {
				this.delTaskPic(id);
			} catch (e) {
			}
			taskDao.delLocalById(id);
			break;
		default:
			break;
		}
	};
	/**
	 * 删除特殊记录上报照片
	 */
	this.delSpecialUpPic = function(id) {
		var specialUp = getSpecialUpById();
		var v = new XMLDocument();
		var formXml = specialUp.form;
		v.parseXmlText(formXml);
		var form = v.rootElement;
		var fields = form.childNodes;
		for (var i = 0; i < fields.length; i++) {
			var field = fields[i];
			var kind = field.getAttribute("kind");
			var value = field.getAttribute("value");
			switch (parseInt(kind)) {
			case 6:
				var picFile = new File(value, false);
				if (picFile.exists()) {
					var isSuccess = picFile.deleteFile();
				}
				break;
			}
		}

	}
	/**
	 * 删除待办任务照片
	 */
	this.delTaskPic = function(id) {
		var task = taskDao.getLocalById(id);
		var v = new XMLDocument();
		v.parseXmlText(task.form);
		var form = v.rootElement;
		var fields = form.childNodes;
		for (var i = 0; i < fields.length; i++) {
			var field = fields[i];
			var kind = field.getAttribute("kind");
			var value = field.getAttribute("value");
			switch (parseInt(kind)) {
			case 6:
				delPhotoDir(value);
				break;
			}
		}
	}
	/**
	 * 删除店面本地照片
	 * @param id
	 */
	this.delStorePic = function(id) {
		var store = storeDao.getLocalById(id);
		var v = new XMLDocument();
		var formXml = store.form;
		v.parseXmlText(formXml);
		// 表单xml结构数据
		var form = v.rootElement;
		var fields = form.childNodes;
		for (var i = 0; i < fields.length; i++) {
			var field = fields[i];
			var type = field.getAttribute("type");
			var value = field.getAttribute("value");
			switch (parseInt(type)) {
			case 2:
				if (!value.isEmpty()) {
					delPhotoDir(value);
				}
				break;
			default:
				break;
			}
		}
	};
	/**
	 * 删除巡店本地照片
	 */
	this.delStoreVisitPic = function(id) {
		var storeVisit = storeVisitDao.getLocalById(id);
		try {
			var v = new XMLDocument();
			v.parseXmlText(storeVisit.form);
			var form = v.rootElement;
			var types = form.childNodes;
			for (var k = 0; k < types.length; k++) {
				//该类型所有字段
				var type = types[k];
				var fields = type.childNodes;
				for (var i = 0; i < fields.length; i++) {
					var field = fields[i];
					var kind = field.getAttribute("kind");
					var value = field.getAttribute("value");
					if (!value.isEmpty()) {
						switch (parseInt(kind)) {
						case 6:
							delPhotoDir(value);
							break;
						}
					}
					var sons = field.childNodes;
					if (null != sons) {
						if (sons.length > 0) {
							for (var x = 0; x < sons.length; x++) {
								var tagName = sons[x].name;
								if (tagName == "son") {
									var sv = sons[x].getAttribute("value");
									var sk = sons[x].getAttribute("kind");
									if (!sv.isEmpty()) {
										switch (parseInt(sk)) {
										case 6:
											delPhotoDir(sv);
											break;
										}
									}
								}
							}
						}
					}
				}
			}
		} catch (e) {
		}
		storeVisitDao.delLocalById(id);
	};
	/**
	 * 删了客户拜访本地照片
	 */
	this.delCustomerVisitPic = function(id) {
		var customerVisit = customerVisitDao.getLocalById(id);
		var v = new XMLDocument();
		v.parseXmlText(customerVisit.form);
		var form = v.rootElement;
		var fields = form.childNodes;
		for (var i = 0; i < fields.length; i++) {
			var field = fields[i];
			var kind = field.getAttribute("kind");
			var value = field.getAttribute("value");
			switch (parseInt(kind)) {
			case 6:
				delPhotoDir(value);
				break;
			}
		}
	};
	/**
	 * 删除经销商本地照片
	 */
	this.delDealerVisitPic = function(id) {
		var dealerVisit = dealerVisitDao.getLocalById(id);
		var v = new XMLDocument();
		v.parseXmlText(dealerVisit.form);
		var form = v.rootElement;
		var fields = form.childNodes;
		for (var i = 0; i < fields.length; i++) {
			var field = fields[i];
			var kind = field.getAttribute("kind");
			var value = field.getAttribute("value");
			switch (parseInt(kind)) {
			case 6:
				delPhotoDir(value);
				break;
			}
		}
	};
	/**
	 * 待传报告初始化查询
	 */
	this.init = function() {
		var wuArr = this.getAllUploads();
		if (wuArr.length > 0) {
			var result = [];
			for (var i = 0; i < wuArr.length; i++) {
				var wu = wuArr[i];
				var id = wu.id;
				var type = wu.type;
				var isAdd = wu.isAdd;
				var d = new Date();
				d.setTime(wu.id);
				var s="-";
				var dn=d.getFullYear()+s+(d.getMonth()+1<10?"0":"")+(d.getMonth()+1)+s+(d.getDate()<10?"0":"")+d.getDate()+" ";
				var s=":";
				dn+= (d.getHours()<10?"0":"")+d.getHours()+s+(d.getMinutes()<10?"0":"")+d.getMinutes()+s+(d.getSeconds()<10?"0":"")+d.getSeconds();
				var name = this.getTypeName(type) + "(" + dn + ")";
				var row = "<listitem type='twoline' checkbox='' id='items" + i + "' name='" + id + "-" + type + "' href='getWatiUploadDetail("
				row += id + "," + type + "," + isAdd + ")' caption='" + name + "' sndcaption='" + wu.name + "'  target='_blank' />";
				result.push(row);
			}
			if (result.length > 0) {
				this.showResponse(result.join(""));
			} else {
				this.noResultShow();
			}
		} else {
			this.noResultShow();
		}
	};
	/**
	 * 查无数据
	 */
	this.noResultShow = function() {
		var msg = "暂无待传数据！";
		var c = "<font style=\"color:black;font-size:1.2em;text-align:center;\">" + msg + "</font>";
		this.showResponse(c);
	};
	/**
	 * 输出结果
	 *
	 * @param content
	 */
	this.showResponse = function(content) {
		var mdiv = document.getElementById("divcontent");
		mdiv.innerHTML = content;
	};
}

/**
 *
 * @param id
 * @param type
 */
function getWatiUploadDetail(id, type, isAdd) {
	var url;
	switch (type) {
	case TYPE_STORE_VISIT:
		url = "res:page/localStoreVisit.xhtml";
		window.open(url, true, false, "", "id=" + id);
		break;
	case TYPE_STORE_INFO:
		url = "res:page/locaStoreInfo.xhtml";
		window.open(url, true, false, "", "id=" + id);
		break;
	case TYPE_CUSTOMER_VISIT:
		url = "res:page/localCustomerVisit.xhtml";
		window.open(url, true, false, "", "id=" + id);
		break;
	case TYPE_CUSTOMER_INFO:
		if (isAdd == 0) {
			url = "res:page/localCustomer.xhtml";
		} else {
			url = "res:page/localCustomerAdd.xhtml";
		}
		window.open(url, true, false, "", "id=" + id);
		break;
	case TYPE_DEALER_VISIT:
		url = "res:page/localDealerVisit.xhtml";
		window.open(url, true, false, "", "id=" + id);
		break;
	case TYPE_DEALER_INFO:
		if (isAdd == 0) {
			url = "res:page/localDealer.xhtml";
		} else {
			url = "res:page/localDealerAdd.xhtml";
		}
		window.open(url, true, false, "", "id=" + id);
		break;
	case TYPE_SPECIALUP:
		if (isAdd == 1) {
			url = "res:page/specialUpEdit1b.xhtml";
		} else if (isAdd == 2) {
			url = "res:page/specialUpEdit2b.xhtml";
		} else if (isAdd == 3) {
			url = "res:page/specialUpEdit3b.xhtml";
		} else {
			url = "res:page/specialUpEdit4.xhtml";
		}
		window.open(url, true, false, "", "id=" + id);
		break;
	case TYPE_TASK:
		url = "res:page/localTask.xhtml";
		window.open(url, true, false, "", "id=" + id);
		break;
	default:
		break;
	}
}
